package completeOneWayTerminatingWait;

import java.util.List;

import org.objectweb.proactive.Body;
import org.objectweb.proactive.api.PAActiveObject;
import org.objectweb.proactive.core.component.body.ComponentInitActive;

public class Collector implements CollectorInterface, TerminatorInterface, ComponentInitActive {

	int ntasks = 0;	        // to be communicated by master, actually ...
	int i = 0; 				// the number of results delivered
	SyncPlain mon = null; 		// used to block the hasTerminated requester

	public Collector() {
		// mon = new Sync(ntasks);  // moved below, otherwise initialized to 0
	}
	
	@Override
	public void deliver(List<Integer> res) {
		System.err.println(":: deliver ENTERED ");
		java.util.Iterator<Integer> it = res.iterator();
		while(it.hasNext()) {
			System.err.println(":: result time :: "+it.next());
			i++;
			System.out.println("going to call mon.deliver()");
			mon.deliver();
			System.out.println("called mon.deliver()");
		}
		System.err.println(":: deliver terminating ");
	}

	@Override
	public boolean hasTerminated() {
		System.err.println(":: hasTerminated entered ...");
		mon.hasTerminated(ntasks);
		return true;
	}

	public void setTaskNo(int t) {
		ntasks = t; 
		mon = new SyncPlain(ntasks);			// be carefull : this works only if the setTaskNo is the first service called !!!!
		return;
	}

	@Override
	public void initComponentActivity(Body arg0) {
		// TODO Auto-generated method stub
		PAActiveObject.setImmediateService("hasTerminated");
	}


}
