package completeOneWayTerminatingWait;

import java.util.List;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;

public class MasterComponent implements BindingController, MasterComponentInterface {
	/**
	 * this is the varaible binded through the binding controller at deployment time, when the ADL of the composite component is processed 
	 */
	SimpleComponentMulticastInterface slaves = null; 		
	
	/**
	 * constructor(void) needed for serialization	
	 */
	public MasterComponent() {}
	
	/**
	 * interface to be promoted as composite component service 
	 * @return 
	 */
	public void  doWork(List<Integer> tasks) {
		slaves.doWork(tasks);
		return;
	}

	/**
	 * methods require because of the composite (Binding interface)
	 */
	
	@Override
	public void bindFc(String clientItfName, Object serverItf)
			throws NoSuchInterfaceException, IllegalBindingException,
			IllegalLifeCycleException {
		if(clientItfName.equals("simple-component-interface")) {
			slaves = (SimpleComponentMulticastInterface) serverItf;
		} else {
			throw new NoSuchInterfaceException(clientItfName);
		}
	}

	@Override
	public String[] listFc() {
		String[] s =  {"simple-component-interface"};
		return s;
	}

	@Override
	public Object lookupFc(String clientItfName) throws NoSuchInterfaceException {
		if(clientItfName.equals("simple-component-interface"))
			return slaves;
		else 
			throw new NoSuchInterfaceException(clientItfName);
	}

	@Override
	public void unbindFc(String clientItfName) throws NoSuchInterfaceException,
			IllegalBindingException, IllegalLifeCycleException {
		if(clientItfName.equals("simple-component-interface"))
			slaves = null; 
		else
			throw new NoSuchInterfaceException(clientItfName);
	}

}
