package completeOneWayTerminatingWait;

import java.net.UnknownHostException;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;

import collective.SimpleComponentMulticastInterface;

public class SimpleComponent implements SimpleComponentInterface, BindingController {

	CollectorGathercastInterface collector = null; 

	@Override
	public void doWork(Integer task) {
		int iv = task.intValue();
		System.err.println(":: doWork computing "+iv+" at "+this+" got task "+task+":"+task.getClass().getName());
		Integer res = new Integer(++iv);
		try {
			Thread.sleep(2000);
		} catch (InterruptedException e) {
			System.err.println(":: Interrupted ");
		}
		collector.deliver(res);
		System.err.println(":: doWork delivered! (at "+this+")");
		return;
	}

	@Override
	public void bindFc(String clientItfName, Object serverItf)
	throws NoSuchInterfaceException, IllegalBindingException,
	IllegalLifeCycleException {
		if(clientItfName.equals("collector-component-interface")) {
			collector = (CollectorGathercastInterface) serverItf;
		} else {
			throw new NoSuchInterfaceException(clientItfName);
		}
	}


	@Override
	public String[] listFc() {
		String[] s =  {"simple-component-interface"};
		return s;
	}

	@Override
	public Object lookupFc(String clientItfName) throws NoSuchInterfaceException {
		if(clientItfName.equals("collector-component-interface"))
			return collector;
		else 
			throw new NoSuchInterfaceException(clientItfName);
	}

	@Override
	public void unbindFc(String clientItfName) throws NoSuchInterfaceException,
	IllegalBindingException, IllegalLifeCycleException {
		if(clientItfName.equals("colllector-component-interface"))
			collector = null; 
		else
			throw new NoSuchInterfaceException(clientItfName);
	}

}
