package completeOneWayTerminatingWait;

import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class Sync {

	private int i = 0; 
	private int limit = 0; 

	final Lock lock = new ReentrantLock();
	final Condition full  = lock.newCondition(); 

	public Sync(int limit) {
		this.limit = limit;
	}

	public void deliver() {
		System.out.println(":: deliver locked >> got the "+i+"-th value");
		lock.lock();
		try {
			i++;
			if(i==limit) {
				System.out.println(":. deliver >> signalling  ...");
				full.signal();
			}
		} finally {
			lock.unlock();
		}
		System.out.println(":: deliver locked >> return");
		return;
	}

	public boolean hasTerminated(int lim) {
		System.out.println(":: hasTerminated locked >> entered");
		lock.lock(); 
		try {
			while(lim != i) {
				try {
					System.out.println(":: going to await()");
					full.await();
					System.out.println("awaited");
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		} finally {
			lock.unlock();
		}
		System.out.println(":: hasTerminated locked >> return true");
		return true;
	}
}
