package completeOneWayTerminatingWait;

import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class SyncPlain {

	private int i = 0; 
	private int limit = 0; 

	public SyncPlain(int limit) {
		this.limit = limit;
	}

	public synchronized void deliver() {
		System.out.println(":: deliver locked >> got the "+i+"-th value");
		i++;
		if(i==limit) {
			System.out.println(":. deliver >> signalling  ...");
			notifyAll();
		}
		System.out.println(":: deliver locked >> return");
		return;
	}

	public synchronized boolean hasTerminated(int lim) {
		System.out.println(":: hasTerminated locked >> entered");
		while(lim != i) {
			try {
				System.out.println(":: going to await()");
				wait();
				System.out.println("awaited");
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		System.out.println(":: hasTerminated locked >> return true");
		return true;
	}
}
