package completeOneWayTerminatingWait;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.util.Fractal;

import adles2.SecondComponentInterface;

public class Test {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			// get factory to instantiate the component from ADL 
			Factory f = org.objectweb.proactive.core.component.adl.FactoryFactory.getFactory();
			// the has table is used to set up the context
			Map<String, Object> context = new HashMap<String, Object>();

			Component composite = (Component) f.newComponent("completeOneWayTerminatingWait.adl.Composite", context);
			System.out.println(":: Composite Component created ...");

			Fractal.getLifeCycleController(composite).startFc();
			System.out.println(":: Component started ...");


			MasterComponentInterface sc = ((MasterComponentInterface) composite.getFcInterface("outer-component-interface"));
			TerminatorInterface terminator = ((TerminatorInterface) composite.getFcInterface("outer-terminator-interface"));
			
			int taskNo = 4; 
			List<Integer> params = new ArrayList<Integer>();
			for(int i=0; i<taskNo; i++)
				params.add(new Integer(i));

			terminator.setTaskNo(taskNo);	// tell the collector how many results should be awaited
			
			System.err.print(":: list of params is = <");
			Iterator<Integer> it = params.iterator();
			while(it.hasNext()) 
				System.err.print(it.next()+":");
			System.err.println(">");

			sc.doWork(params);
			
			// handling termination, the busy wait way (too bad!)
			System.err.println(":: called computation on inner nodes via multicast interface (scatter) ");
			while(!terminator.hasTerminated()) {
				try { Thread.sleep(1000); } catch(InterruptedException e) {} 
				System.err.println(":: TEST awaiting termination of collector ...");
			}
			System.err.println(":: collector terminated\n:: stopping component(s) ");
			// stopping the composite component (and all the inner components as a consequence) 
			Fractal.getLifeCycleController(composite).stopFc();
			
			System.err.println(":: exiting");
			System.exit(0);

		} catch (Exception e) {
			e.printStackTrace();
			System.exit(0);
		}

	}

}
