package vnes0;

import java.util.HashMap;
import java.util.Map;

import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.util.Fractal;
import org.objectweb.proactive.api.PADeployment;
import org.objectweb.proactive.core.descriptor.data.ProActiveDescriptor;

public class Main {
	
	public static void main(String [] args) {
		
		try {
			// get factory to instantiate the component from ADL 
			Factory f = org.objectweb.proactive.core.component.adl.FactoryFactory.getFactory();
			// the has table is used to set up the context
	        Map<String, Object> context = new HashMap<String, Object>();
	        
			ProActiveDescriptor deploymentDescriptor =  
				PADeployment.getProactiveDescriptor("vnes0/distributed.xml");
			// add descriptor to the context
			context.put("deployment-descriptor", deploymentDescriptor);
			// activate mappings
			deploymentDescriptor.activateMappings();
			System.err.println("mapping activated\nnow starting component deploymnet");

			
			Component simpleComponent = (Component) f.newComponent("vnes0.SimpleComponent", context);
	        System.out.println(":: Component created ...");
	        
	        Fractal.getLifeCycleController(simpleComponent).startFc();
			System.out.println(":: Component started ...");
			
			
			SimpleComponentInterface sc = ((SimpleComponentInterface) simpleComponent.getFcInterface("simple-comp-interface"));
			Object n = sc.doWork(new Integer(5));
			System.out.println(":: Object coming back of type : "+n.getClass().getName());
			
			System.out.println(":: Computed sc.doWork(5)="+n.toString());
			
			
	        Fractal.getLifeCycleController(simpleComponent).stopFc();
			System.out.println(":: Component stopped ...");
			
			System.exit(0);
			
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(0);
		}
		
	}

}
