package vnes1;

import java.io.Serializable;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;

public class SecondComponent implements SecondComponentInterface, Serializable, BindingController {

	SimpleComponentInterface otherComponent; 
	
	public SecondComponent() {
		// empty
		return;
	}

	public Integer compute(Integer task) {
		// call other component
		try {
			String localMachine1 = java.net.InetAddress.getLocalHost().getCanonicalHostName();
			System.err.println(":: SecondComponent :: Hostname of local machine: " + localMachine1);
		} catch (Exception e) {
			e.printStackTrace();
		}
		Integer temp = otherComponent.doWork(task);
		System.err.println("--- called SimpleComponent, got "+temp+" type "+temp.getClass().getName());
		// post process result
		int i = temp.intValue();
		// return new result
		return new Integer(i*2);
	}

	public void bindFc(String arg0, Object arg1)
			throws NoSuchInterfaceException, IllegalBindingException,
			IllegalLifeCycleException {

		if(arg0.equals("simple-comp-interface")) {
			otherComponent = (SimpleComponentInterface) arg1;
		}
	}

	public String[] listFc() {
		String [] itf = new String[1];
		itf[0] = "simple-comp-interface";
		return itf;
	}

	public Object lookupFc(String arg0) throws NoSuchInterfaceException {
		if(arg0.equals("simple-comp-interface")) {
			return otherComponent;
		}
		return null;
	}

	public void unbindFc(String arg0) throws NoSuchInterfaceException,
			IllegalBindingException, IllegalLifeCycleException {

		if(arg0.equals("simple-comp-interface")) {
			otherComponent = null;
		}
}

	
	
	
}
