package vnes1;

import java.util.HashMap;
import java.util.Map;

import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.util.Fractal;
import org.objectweb.proactive.api.PADeployment;
import org.objectweb.proactive.core.descriptor.data.ProActiveDescriptor;

public class Test {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			// get the Factory 
			Factory f = (Factory) org.objectweb.proactive.core.component.adl.FactoryFactory.getFactory();
			System.err.println(":: GOT FACTORY");
			// create the context
			Map<String, Object> context = new HashMap<String, Object>();
			System.err.println(":: CREATED CONTEXT MAP");
			// find the ProActiveDescriptor (this is the one hosting the virtual node definition and mapping 
			ProActiveDescriptor deploymentDescriptor =  
				PADeployment.getProactiveDescriptor("file:///home/marcod/cccp/vnes1/pianosa.xml");
			System.err.println(":: GOT PROACTIVE DESCRIPTOR");
			// add descriptor to the context
			context.put("deployment-descriptor", deploymentDescriptor);
			System.err.println(":: PUT DESCRIPTOR IN CONTEXT");
			// activate mappings
			deploymentDescriptor.activateMappings();
			System.err.println(":: ACTIVATED MAPPINGS");
			System.err.println("mapping activated\nnow starting component deploymnet");
			
			Component composite = (Component) f.newComponent("vnes1.Composite", context);
	             	System.out.println(":: Composite Component created ...");
	        
	        	Fractal.getLifeCycleController(composite).startFc();
			System.err.println(":: Component started ...");
			
			
			SecondComponentInterface sc = ((SecondComponentInterface) composite.getFcInterface("outer-comp-interface"));
			Object n = sc.compute(new Integer(5));
			System.out.println(":: Object coming back of type : "+n.getClass().getName());
			
			System.out.println(":: Computed sc.compute(5)="+n.toString());
//			
//			
//	        	Fractal.getLifeCycleController(simpleComponent).stopFc();
//			System.out.println(":: Component stopped ...");
			
			System.out.println("Press <enter> to continue"); 
			System.in.read(); // wait for user ok
			deploymentDescriptor.killall(false); // then kill JVMs used to deploy components 
			// and eventually exit
			System.exit(0);
			
		} catch (Exception e) {
			e.printStackTrace();
	}

	}
}
