package vnes1;

import java.util.HashMap;
import java.util.Map;

import org.objectweb.fractal.adl.Factory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.control.LifeCycleController;
import org.objectweb.fractal.api.factory.GenericFactory;
import org.objectweb.fractal.api.type.ComponentType;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.api.type.TypeFactory;
import org.objectweb.fractal.util.Fractal;
import org.objectweb.proactive.api.PADeployment;
import org.objectweb.proactive.core.component.Constants;
import org.objectweb.proactive.core.component.ContentDescription;
import org.objectweb.proactive.core.component.ControllerDescription;
import org.objectweb.proactive.core.component.factory.ProActiveGenericFactory;
import org.objectweb.proactive.core.descriptor.data.ProActiveDescriptor;
import org.objectweb.proactive.core.descriptor.data.VirtualNode;
import org.objectweb.proactive.core.node.Node;

import vnes1.SecondComponentInterface;

public class Test {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			// get the Factory 
			Factory f = (Factory) org.objectweb.proactive.core.component.adl.FactoryFactory.getFactory();
			// create the context
			Map<String, Object> context = new HashMap<String, Object>();
			// find the ProActiveDescriptor (this is the one hosting the virtual node definition and mapping 
			ProActiveDescriptor deploymentDescriptor =  
				PADeployment.getProactiveDescriptor("file:///Users/marcodanelutto/Documents/Ricerca/Muskel/ProActiveCCP/src/vnes1/vnes1descr.xml");
			// add descriptor to the context
			context.put("deployment-descriptor", deploymentDescriptor);
			// activate mappings
			deploymentDescriptor.activateMappings();
			
//			Component first = (Component) f.newComponent("vnes1.SimpleComponent", context);
			// now create components 
			Component composite = (Component) f.newComponent("vnes1.Composite", context);
	        System.out.println(":: Composite Component created ...");
	        
	        Fractal.getLifeCycleController(composite).startFc();
			System.out.println(":: Component started ...");
			
			
			SecondComponentInterface sc = ((SecondComponentInterface) composite.getFcInterface("outer-comp-interface"));
			Object n = sc.compute(new Integer(5));
			System.out.println(":: Object coming back of type : "+n.getClass().getName());
			
			System.out.println(":: Computed sc.compute(5)="+n.toString());
//			
//			
//	        Fractal.getLifeCycleController(simpleComponent).stopFc();
//			System.out.println(":: Component stopped ...");
			
			System.out.println("Press <enter> to continue"); 
			System.in.read(); // wait for user ok
			deploymentDescriptor.killall(false); // then kill JVMs used to deploy components 
			// and eventually exit
			System.exit(0);
			
		} catch (Exception e) {
			e.printStackTrace();
	}

	}
}
